/* This program is Copyright © 2013-2014 Charo I. Del Genio */

/* Licensed under the Academic Free License version 3.0

1) Grant of Copyright License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, for the duration of the copyright,
   to do the following:
    a) to reproduce the Original Work in copies, either alone or as part
       of a collective work;
    b) to translate, adapt, alter, transform, modify, or arrange the Original
       Work, thereby creating derivative works ("Derivative Works") based
       upon the Original Work;
    c) to distribute or communicate copies of the Original Work and
       Derivative Works to the public, under any license of your choice that
       does not contradict the terms and conditions, including Licensor's
       reserved rights and remedies, in this Academic Free License;
    d) to perform the Original Work publicly; and
    e) to display the Original Work publicly.

2) Grant of Patent License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, under patent claims owned or
   controlled by the Licensor that are embodied in the Original Work as
   furnished by the Licensor, for the duration of the patents, to make, use,
   sell, offer for sale, have made, and import the Original Work and
   Derivative Works.

3) Grant of Source Code License. The term "Source Code" means the preferred
   form of the Original Work for making modifications to it and all available
   documentation describing how to modify
   the Original Work. Licensor agrees to provide a machine-readable copy of
   the Source Code of the Original Work along with each copy of the Original
   Work that Licensor distributes. Licensor reserves the right to satisfy
   this obligation by placing a machine-readable copy of the Source Code in
   an information repository reasonably calculated to permit inexpensive
   and convenient access by You for as long as Licensor continues to
   distribute the Original Work.

4) Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior permission of the Licensor. Except as
   expressly stated herein, nothing in this License grants any license to
   Licensor's trademarks, copyrights, patents, trade secrets or any other
   intellectual property. No patent license is granted to make, use, sell,
   offer for sale, have made, or import embodiments of any patent claims other
   than the licensed claims defined in Section 2. No license is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under terms different from this License any Original Work that
   Licensor otherwise would have a right to license.

5) External Deployment. The term "External Deployment" means the use,
   distribution, or communication of the Original Work or Derivative Works in
   any way such that the Original Work or Derivative Works may be used by
   anyone other than You, whether those works are distributed or communicated
   to those persons or made available as an application intended for use over
   a network. As an express condition for the grants of license hereunder, You
   must treat any External Deployment by You of the Original Work or a
   Derivative Work as a distribution under section 1(c).

6) Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent, or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and
   any descriptive text identified therein as an "Attribution Notice." You
   must cause the Source Code for any Derivative Works that You create to
   carry a prominent Attribution Notice reasonably calculated to inform
   recipients that You have modified the Original Work.

7) Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that
   the copyright in and to the Original Work and the patent rights granted
   herein by Licensor are owned by the Licensor or are sublicensed to You
   under the terms of this License with the permission of the contributor(s)
   of those copyrights and patent rights. Except as expressly stated in the
   immediately preceding sentence, the Original Work is provided under this
   License on an "AS IS" BASIS and WITHOUT WARRANTY, either express or
   implied, including, without limitation, the warranties of non-infringement,
   merchantability or fitness for a particular purpose. THE ENTIRE RISK AS TO
   THE QUALITY OF THE ORIGINAL WORK IS WITH YOU. This DISCLAIMER OF WARRANTY
   constitutes an essential part of this License. No license to the Original
   Work is granted by this License except under this disclaimer.

8) Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to anyone for any indirect, special, incidental, or
   consequential damages of any character arising as a result of this License
   or the use of the Original Work including, without limitation, damages for
   loss of goodwill, work stoppage, computer failure or malfunction, or any and
   all other commercial damages or losses. This limitation of liability shall
   not apply to the extent applicable law prohibits such limitation.

9) Acceptance and Termination. If, at any time, You expressly assented to this
   License, that assent indicates your clear and irrevocable acceptance of this
   License and all of its terms and conditions. If You distribute or
   communicate copies of the Original Work or a Derivative Work, You must make
   a reasonable effort under the circumstances to obtain the express assent of
   recipients to the terms of this License. This License conditions your rights
   to undertake the activities listed in Section 1, including your right to
   create Derivative Works based upon the Original Work, and doing so without
   honoring these terms and conditions is prohibited by copyright law and
   international treaty. Nothing in this License is intended to affect
   copyright exceptions and limitations (including "fair use" or "fair
   dealing"). This License shall terminate immediately and You may no longer
   exercise any of the rights granted to You by this License upon your failure
   to honor the conditions in Section 1(c).

10) Termination for Patent Action. This License shall terminate automatically
    and You may no longer exercise any of the rights granted to You by this
    License as of the date You commence an action, including a cross-claim or
    counterclaim, against Licensor or any licensee alleging that the Original
    Work infringes a patent. This termination provision shall not apply for an
    action alleging patent infringement by combinations of the Original Work
    with other software or hardware.

11) Jurisdiction, Venue and Governing Law. Any action or suit relating to this
    License may be brought only in the courts of a jurisdiction wherein the
    Licensor resides or in which Licensor conducts its primary business, and
    under the laws of that jurisdiction excluding its conflict-of-law
    provisions. The application of the United Nations Convention on Contracts
    for the International Sale of Goods is expressly excluded. Any use of the
    Original Work outside the scope of this License or after its termination
    shall be subject to the requirements and penalties of copyright or patent
    law in the appropriate jurisdiction. This section shall survive the
    termination of this License.

12) Attorneys' Fees. In any action to enforce the terms of this License or
    seeking damages relating thereto, the prevailing party shall be entitled to
    recover its costs and expenses, including, without limitation, reasonable
    attorneys' fees and costs incurred in connection with such action,
    including any appeal of such action. This section shall survive the
    termination of this License.

13) Miscellaneous. If any provision of this License is held to be
    unenforceable, such provision shall be reformed only to the extent
    necessary to make it enforceable.

14) Definition of "You" in This License. "You" throughout this License, whether
    in upper or lower case, means an individual or a legal entity exercising
    rights under, and complying with all of the terms of, this License. For
    legal entities, "You" includes any entity that controls, is controlled by,
    or is under common control with you. For purposes of this definition,
    "control" means (i) the power, direct or indirect, to cause the direction
    or management of such entity, whether by contract or otherwise, or (ii)
    ownership of fifty percent (50%) or more of the outstanding shares, or
    (iii) beneficial ownership of such entity.

15) Right to Use. You may use the Original Work in all ways not otherwise
    restricted or conditioned by this License or by law, and Licensor promises
    not to interfere with or be responsible for such uses by You.

16) Modification of This License. This License is Copyright © 2005 Lawrence
    Rosen. Permission is granted to copy, distribute, or communicate this
    License without modification. Nothing in this License permits You to modify
    this License as applied to the Original Work or to Derivative Works.
    However, You may modify the text of this License and copy, distribute or
    communicate your modified version (the "Modified License") and apply it to
    other original works of authorship subject to the following conditions: (i)
    You may not indicate in any way that your Modified License is the "Academic
    Free License" or "AFL" and you may not use those names in the name of your
    Modified License; (ii) You must replace the notice specified in the first
    paragraph above with the notice "Licensed under <insert your license name
    here>" or with a notice of your own that is not confusingly similar to the
    notice in this License; and (iii) You may not claim that your original
    works are open source software unless your Modified License has been
    approved by Open Source Initiative (OSI) and You comply with its license
    review and certification process.
*/




#include"PLBDSgen.h"




/* Clean used memory */
void plbdsclean(void)
{
	free(probs[0]);
	free(probs);
	free(dd);
	free(seq[0]);
	free(seq);
	
	
	return;
}




/* Power-law distributed bi-degree sequence initializer */
void plbdsinit(const int n, const double gamin, const double gamout)
{
	int i;
	double logsum, logsumtmp, logsum2;
	
	nodes = n;
	
	/* Allocate memory for needed data */
	seq      = malloc(nodes*sizeof(int*));			// Bi-degree sequence
	seq[0]   = malloc(2*nodes*sizeof(int));
	dd       = malloc(nodes*sizeof(double));		// Degree distribution of the constrained degrees
	probs    = malloc(2*sizeof(double*));			// Cumulative probability distributions
	probs[0] = malloc(2*nodes*sizeof(double));
	probs[1] = probs[0] + nodes;
	for (i=1; i<nodes; i++) seq[i] = seq[i-1] + 2;
	
	gam[0] = gamin;
	gam[1] = gamout;
	
	if (gam[0]<gam[1]) {							// If the in-degrees have a lower exponent,
		dir = 0;									// extract the in-degrees freely
		mc = 1;										// and constrain the out-degrees;
	} else if (gam[0]>=gam[1]) {					// otherwise,
		dir = 1;									// do the other way around.
		mc = 0;
	}
	
	/* Compute the logarithm of the normalization constant for the directly extracted degrees */
	logsum = 0.0;
	for (i=2; i<nodes; i++) {
		logsumtmp = -gam[dir]*log(i);
		logsum = fmax(logsum,logsumtmp) + log1p(exp(-fabs(logsum-logsumtmp)));
	}
	
	/* Compute the cumulative probability distributions for the directly extracted degrees */
	probs[dir][0] = 0.0;
	for (i=1; i<nodes; i++) {
		logsumtmp = -gam[dir]*log(i) - logsum;
		probs[dir][i] = fmax(probs[dir][i-1],logsumtmp) + log1p(exp(-fabs(probs[dir][i-1]-logsumtmp)));
	}
	
	if (gam[0]!=gam[1]) {																						// If the exponents are different
		logsum2 = 0.0;																							// Repeat the calculation for the
		for (i=2; i<nodes; i++) {																				// conditioned degrees
			logsumtmp = -gam[mc]*log(i);
			logsum2 = fmax(logsum2,logsumtmp) + log1p(exp(-fabs(logsum2-logsumtmp)));
		}
		probs[mc][0] = 0.0;
		for (i=1; i<nodes; i++) {
			logsumtmp = -gam[mc]*log(i) - logsum2;
			probs[mc][i] = fmax(probs[mc][i-1],logsumtmp) + log1p(exp(-fabs(probs[mc][i-1]-logsumtmp)));
		}
	} else {																									// If instead the exponents are equal,
		logsum2 = logsum;																						// the normalization constants and the
		for (i=1; i<nodes; i++) probs[mc][i] = probs[dir][i];													// and the cumulative distributions are the same
	}
	
	
	return;
}




/* Extract a graphical bi-degree sequence with using the initialized quantities */
int **plbdsgen(double (*rng)(void))
{
	
	int i, j, min, max;
	long int edges[2];
	double logprob;
	
	
	do {
		if (gam[0]==gam[1]) {												// If the exponents are equal,
			if (rng()<0.5) {												// randomly choose which degrees to extract directly
				dir = 0;													// and which to constrain on the others.
				mc  = 1;
			} else {
				dir = 1;
				mc  = 0;
			}
		}
		
		do {
			edges[0] = edges[1] = 0;										// Initialize the number of in- and out-stubs
			for (i=0; i<nodes; i++) {										// Extract the directly extracted degrees
				logprob  = log1p(rng());									// using binary search on the cumulative probability distribution
				min = 1;
				max = nodes-1;
				while (max!=min) {
					j = (min+max)/2;
					if (probs[dir][j]<logprob) min = j+1;
					else if (probs[dir][j]>=logprob) max = j;
				}
				seq[i][dir] = max;											// Update the bi-degree sequence
				edges[dir] += max;											// and the number of stubs
			}
		} while (edges[dir]<nodes);
		for (i=0; i<nodes; i++) {											// Do the same on the constrained degrees
			logprob  = log1p(rng());
			min = 1;
			max = nodes-1;
			while (max!=min) {
				j = (min+max)/2;
				if (probs[mc][j]<logprob) min = j+1;
				else if (probs[mc][j]>=logprob) max = j;
			}
			seq[i][mc] = max;
			edges[mc] += max;
		}
		
		for (i=0; i<nodes; i++) dd[i] = 0.0;								// Initialize the degree distribution vector
		for (i=0; i<nodes; i++) dd[seq[i][mc]] += 1.0/((double) nodes);		// Compute the constrained degree distribution
		
		max = 1;
		while (edges[mc]<edges[dir]) {										// If the number of constrained stubs is less than the number of directly extracted stubs,
			while (dd[max]<1.0/((double) nodes)) max++;						// find the lowest existing degree,
			i = 0;															// then find the first node with that degree
			while (seq[i][mc]!=max) i++;
			seq[i][mc]++;													// and increase its degree by 1.
			
			dd[max]   -= 1.0/((double) nodes);								// Update the degree distribution
			dd[max+1] += 1.0/((double) nodes);
			edges[mc]++;													// and the number of stubs
		}
		
		max = 2;
		while (edges[mc]>edges[dir]) {										// If the number of constrained stubs is more than the number of directly extracted stubs,
			while (dd[max]<1.0/((double) nodes)) max++;						// find the lowest existing degree greater than the lower cutoff,
			i = 0;															// then find the first node with that degree
			while (seq[i][mc]!=max) i++;
			seq[i][mc]--;													// and degrease its degree by 1.
			
			dd[max]   -= 1.0/((double) nodes);								// Update the degree distribution
			dd[max-1] += 1.0/((double) nodes);
			edges[mc]--;													// and the number of stubs
			if (max>2) max--;
		}
		
		lexqsort(seq,nodes);												// Sort the bi-degree sequence lexicographically
	} while (diGTest(seq,nodes)!=1);										// and repeat all this until a graphical sequence is found.
	
	
	return seq;
}




/* Fast and efficient directed graphicality test
   It returns 1 if the bi-degree sequence is graphical,
   -1 if the number of in-stubs is not equal to the number of out-stubs,
   0 if the sequence is otherwise non-graphical */
static int diGTest(int **s, const int n)
{
	int t, G[n+1], S[n+1];
	long int lhs=0, rhs=0, gtilde;
	
	for (t=0; t<n; t++) {
		S[t] = G[t] = 0;
		lhs += s[t][0];
		rhs += s[t][1];
	}
	G[n] = S[n] = 0;
	
	if (lhs!=rhs) return -1;
	
	G[s[0][1]+1] = 1;
	for (t=1; t<n; t++) {
		G[s[t][1]]++;
		if (s[t][1] >= t+1)  S[s[t][1]]--;
		if (s[t][1]+1 > t+1) S[s[t][1]+1]++;
	}
	
	lhs    = s[0][0];
	rhs    = n-1-G[0];
	gtilde = G[0]+G[1];
	t = 1;
	while (t<n-1 && lhs<=rhs) {
		t++;
		lhs += s[t-1][0];
		rhs += n-gtilde;
		if (s[t-1][1]>=t) rhs--;
		gtilde += G[t]+S[t];
	}
	
	if (lhs>rhs) return 0;
	else return 1;
}




/* Lexicographical quicksort */
static void lexqsort(int **s, const int n)
{
	int i, anyone, pivotin, pivotout, l_ind=0, s_ind=0, h_ind=0, **lower, **higher, **same;
	
	if (n<=1) return;
	
	lower     = malloc(n*sizeof(int*));
	lower[0]  = calloc(2*n,sizeof(int));
	higher    = malloc(n*sizeof(int*));
	higher[0] = calloc(2*n,sizeof(int));
	same      = malloc(n*sizeof(int*));
	same[0]   = calloc(2*n,sizeof(int));
	for (i=1;i<n;i++) {
		lower[i]  = lower[i-1]+2;
		higher[i] = higher[i-1]+2;
		same[i]   = same[i-1]+2;
	}
	
	anyone = (int) (floor ( ( ( (double) rand() ) / ( (double) RAND_MAX ) ) * (double) n ));
	pivotin  = s[anyone][0];
	pivotout = s[anyone][1];
	
	for (i=0;i<n;i++) {
		if (s[i][0]<pivotin) {
			lower[l_ind][0]   = s[i][0];
			lower[l_ind++][1] = s[i][1];
		} else if (s[i][0]>pivotin) {
			higher[h_ind][0]   = s[i][0];
			higher[h_ind++][1] = s[i][1];
		} else if (s[i][1]<pivotout) {
			lower[l_ind][0]   = s[i][0];
			lower[l_ind++][1] = s[i][1];
		} else if (s[i][1]>pivotout) {
			higher[h_ind][0]   = s[i][0];
			higher[h_ind++][1] = s[i][1];
		} else {
			same[s_ind][0]   = s[i][0];
			same[s_ind++][1] = s[i][1];
		}
	}
	
	lexqsort(lower,l_ind);
	lexqsort(higher,h_ind);
	
	if (h_ind) for (i=0;i<h_ind;i++) {
		s[i][0] = higher[i][0];
		s[i][1] = higher[i][1];
	}
	if (s_ind) for (i=h_ind;i<s_ind+h_ind;i++) {
		s[i][0] = same[i-h_ind][0];
		s[i][1] = same[i-h_ind][1];
	}
	if (l_ind) for (i=s_ind+h_ind;i<h_ind+s_ind+l_ind;i++) {
		s[i][0] = lower[i-h_ind-s_ind][0];
		s[i][1] = lower[i-h_ind-s_ind][1];
	}
	
	free(same[0]);
	free(same);
	free(higher[0]);
	free(higher);
	free(lower[0]);
	free(lower);
	
	return;
}
